A very simple command line media uploader to [Flickr](https://www.flickr.com) written in Scala. Uses the [Flickr4Java](https://github.com/callmeal/Flickr4Java) library. Flickr is awesome place to back up personal photos with its 1TB of storage.

The name **Flu** obviously stands for **Fl**ickr **U**ploader, but I also began writing it when I had a flu.

A work in progress, but already uploads the pictures, organizes them into albums, and avoids re-uploading already uploaded pictures.

It is meant mainly for my personal use, and the specific organization of my files. I have all pictures stored in folders by year, then by occasion (albums), and inside each album are the photos themselves.

Example:

  - 2012/Visit to Ostrava
      - 2012/Visit to Ostrava/bored selfie.jpg
      - 2012/Visit to Ostrava/drunk selfie.jpg
  - 2012/Spitting down the Charles bridge
      - 2012/Spitting down the Charles bridge/boat hit.jpg
      - 2012/Spitting down the Charles bridge/swan hit.jpg
  - 2013/Skiing in Krkonose
      - 2013/Skiing in Krkonose/Bottle of rum.jpg
      - 2013/Skiing in Krkonose/Empty bottle.jpg
      - 2013/Skiing in Krkonose/Broken ski.jpg
      - 2013/Skiing in Krkonose/Ambulance chopper.jpg

The idea is, that we create photosets (albums in the new Flickr terminology) for *Visit to Ostrava*, *Spitting down the Charles bridge* and *Skiing in Krkonose* with the appropriate photos inside them, and then make collections *2012*, *2013*, ... of these albums. Unfortunately, Flickr doesn't have collection API implemented yet, so you have to add the photosets to the collections by yourself.

There is a simple caching mechanism implemented. All the uploaded files get tagged with special machine tags, that describe the original path relative to the collection (year in this example). When **Flu** is run, it scans all the files at the beginning (that is relatively fast) to see which files have already been uploaded.

Flu needs to authorize you when run first. It will guide you through the process, and remember the credentials, so you need to do that only once.

## Usage

Just run it and follow the help. Example invocation:

```flu uploadCollection --uploadVideos false "/home/john doe/photos/2014"```

TODO movies. Already supported, but disabled for now, since I need to shrink my movies a bit before uploading